dofile("sys/lua/wrapper.lua");

--Declare Variables
tScore = 0;
ctScore = 0;
hasCtFlag = nil;
hasTFlag = nil;
--holdAmount is the score needed to win, which is incramented by 'amountIncrease' every 5 seconds you hold the flag for.
holdAmount = 30;
amountIncrease = 1;

--Show score graphics and original score
image("sys/lua/holdTheFlag/background1.png", 48, 132, 2);
parse('hudtxt 1 "'..tScore..'" 3 125 0');
parse('hudtxt 0 "'..ctScore..'" 28 125 0');

--prevent flag captures
addhook("flagcapture", "noCap");
function noCap()
	return 1;
end

--start score timers when a flag is picked up
addhook("flagtake", "pickUpFlag");
function pickUpFlag(id, team, x, y)
	if(player(id, "team") == 1)then
		hasTFlag = id;	
		timer(5000,"addTScore","",0);
	else
		hasCtFlag = id;
		timer(5000,"addCtScore","",0);
	end
end

--stop score timers when a flag is dropped
addhook("die", "dropFlag");
addhook("leave", "dropFlag");
function dropFlag(id)
	if(id == hasCtFlag)then
		hasCtFlag = nil;
		freetimer("addCtScore");
	elseif(id == hasTFlag)then
		hasTFlag = nil;
		freetimer("addTScore");
	end
end

--add scores after 5 seconds
function addCtScore()
	ctScore = ctScore + amountIncrease;
	parse('hudtxt 0 "'..ctScore..'" 28 125 0');
	parse('setscore '..hasCtFlag..' '..player(hasCtFlag,"score") + 1);
	
	if(ctScore >= holdAmount)then
		parse('endround 2');
	end
end

function addTScore()
	tScore = tScore + amountIncrease;
	parse('hudtxt 1 "'..tScore..'" 3 125 0');
	parse('setscore '..hasTFlag..' '..player(hasTFlag,"score") + 1);
	
	if(tScore >= holdAmount)then
		parse('endround 1');
	end
end

--reset the variables for a new round
addhook("startround_prespawn", "reset")
function reset()
	tScore = 0;
	ctScore = 0;
	hasCtFlag = nil;
	hasTFlag = nil;
	
	image("sys/lua/holdTheFlag/background1.png", 48, 132, 2);
	parse('hudtxt 1 "'..tScore..'" 3 125 0');
	parse('hudtxt 0 "'..ctScore..'" 28 125 0');
	
	freetimer("addCtScore");
	freetimer("addTScore");	
end

